/* $Id: page.c 40 2023-04-27 07:29:37Z nishi $ */
#include <swinehub/page.h>

#include <swinehub/api.h>
#include <swinehub/config.h>
#include <swinehub/repo.h>
#include <swinehub/language.h>
#include <swinehub.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

void swinehub_create_page(struct swinehub_config* config){
	if(strcmp(getenv("FIRST_PATH"), "/v1") == 0){
		swinehub_api(config);
		return;
	}
	if(strcmp(getenv("ISDAV"), "NO") == 0){
		printf("Content-Type: text/html\r\n");
		if(getenv("FIRST_PATH")[1] == '~'){
			if(swinehub_check_repo(config)){
				printf("Status: 200 OK\r\n");
			}else{
				printf("Status: 404 Not Found\r\n");
			}
		}else if(!(getenv("PATH_REPLACED")[1] == '~' || strcmp(getenv("PATH_REPLACED"), "/") == 0 || strcmp(getenv("PATH_REPLACED"), "/login") == 0 || strcmp(getenv("PATH_REPLACED"), "/signup") == 0 || strcmp(getenv("FIRST_PATH"), "/repo") == 0 || strcmp(getenv("PATH_REPLACED"), "/repos") == 0)){
			printf("Status: 404 Not Found\r\n");
		}else{
			printf("Status: 200 OK\r\n");
		}
		printf("\r\n");
	}else{
		swinehub_repo(config);
		return;
	}
	if(1){
		char* date = malloc(128);
		time_t t = time(NULL);
		struct tm *time_st = localtime(&t);
		strftime(date, 128, "%s", time_st);
		printf("<html>\n");
		printf("	<head>\n");
		printf("		<meta charset=\"UTF-8\">\n");
		printf("		<title>%s</title>\n", config->title);
		printf("		<link rel=\"stylesheet\" href=\"%s?%s\">\n", config->csspath, date);
		printf("		<link rel=\"icon\" href=\"%s\">\n", config->iconpath);
		printf("	</head>\n");
		printf("	<body>\n");
		printf("		<input type=\"hidden\" value=\"%s\" id=\"swinehub-prefix\">\n", getenv("SCRIPT_NAME"));
		printf("		<input type=\"hidden\" value=\"%s\" id=\"swinehub-title\">\n", config->title);
		printf("		<input type=\"hidden\" value=\"%s\" id=\"swinehub-version\">\n", SWINEHUB_VERSION);
		printf("		<div id=\"panel\">\n");
		printf("			<img src=\"%s\" height=\"32px\">\n", config->iconpath);
		printf("			<span class=\"paneltext\">\n");
		printf("				<button onclick=\"location.href = '%s';\">" SW_HOME "</button>\n", getenv("SCRIPT_NAME"));
		printf("				<button id=\"repos-button\" onclick=\"location.href = '%s/repos';\" style=\"display: none;\">" SW_REPOS"</button>\n", getenv("SCRIPT_NAME"));
		printf("				<span id=\"buttons\">\n");
		printf("					<button id=\"login-button\" onclick=\"location.href = '%s/login';\">" SW_LOGIN "</button>\n", getenv("SCRIPT_NAME"));
		if(config->signup){
			printf("					<button id=\"signup-button\" onclick=\"location.href = '%s/signup';\">" SW_SIGNUP "</button>\n", getenv("SCRIPT_NAME"));
		}
		printf("				</span>\n");
		printf("			</span>\n");
		printf("		</div>\n");
		printf("		<div id=\"content\">\n");
		if(strcmp(getenv("PATH_REPLACED"), "/") == 0){
			if(config->itworks == 1){
				SW_IT_WORKS;
			}
			printf("<h2>" SW_YOUR_REPOSITORIES "</h2><div id=\"repositories\">" SW_LOGIN_TO "</div>\n");
		}else if(
				strcmp(getenv("PATH_REPLACED"), "/login") == 0
			||	strcmp(getenv("PATH_REPLACED"), "/signup") == 0){
			printf("<div style=\"text-align: center;\">\n");
			printf("	<h1>%s</h1>\n", strcmp(getenv("PATH_REPLACED"), "/login") == 0 ? SW_LOGIN : SW_SIGNUP);
			printf("	<span class=\"box\">\n");
			printf("		<table border=\"0\">\n");
			printf("			<tr>\n");
			printf("				<th>\n");
			printf("					" SW_USERNAME "\n");
			printf("				</th>\n");
			printf("				<td>\n");
			printf("					<input id=\"username\">\n");
			printf("				</td>\n");
			printf("			</tr>\n");
			printf("			<tr>\n");
			printf("				<th>\n");
			printf("					" SW_PASSWORD "\n");
			printf("				</th>\n");
			printf("				<td>\n");
			printf("					<input id=\"password\" type=\"password\">\n");
			printf("				</td>\n");
			printf("			</tr>\n");
			printf("		</table>\n");
			printf("		<button onclick=\"swinehub_%s()\">%s</button>\n",
					strcmp(getenv("PATH_REPLACED"), "/login") == 0 ? "login" : "signup",
					strcmp(getenv("PATH_REPLACED"), "/login") == 0 ? SW_LOGIN : SW_SIGNUP);
			printf("	</span>\n");
			printf("</div>\n");
		}else if(getenv("FIRST_PATH")[1] == '~'){
			swinehub_repo(config);
		}else if(strcmp(getenv("PATH_REPLACED"), "/repos") == 0){
			printf("<h2>" SW_YOUR_REPOSITORIES "</h2><div id=\"repositories\">" SW_LOGIN_TO "</div>\n");
			printf("<hr>\n");
			printf("<h3>" SW_CREATE_A_REPO "</h3>\n");
			printf("<input id=\"reponame-input\" placeholder=\"" SW_REPO_NAME "\"> <input type=\"button\" id=\"create-repo\" value=\"" SW_CREATE "\" onclick=\"swinehub_create_repo()\" disabled>");
		}else{
			printf("Page Not Found.\n");
		}
		printf("			<div id=\"bottom\">\n");
		printf("				<span class=\"float-left\">\n");
		printf("					<i>Powered by SwineHub Version: <code>%s %s</code></i>\n", SWINEHUB_VERSION, SWINEHUB_ID);
		printf("				</span>\n");
		printf("				<span class=\"float-right\">\n");
		printf("					<a href=\"http://svn.e3t.cc/svn/swinehub/LICENSE\">" SW_LICENSE "</a>\n");
		printf("				</span>\n");
		printf("			</div>\n");
		printf("		</div>\n");
		printf("		<script src=\"%s?%s\"></script>\n", config->scriptpath, date);
		printf("	</body>\n");
		printf("</html>\n");
		free(date);
	}
}
